#include <QCoreApplication>
#include <QDebug>
#include <QStringList>
#include <QFile>
#include <QStorageInfo>
#include <QLibraryInfo>
#include <QFileInfo>

int main(int argc, char *argv[])
{
    QCoreApplication a(argc, argv);
    QStringList args = a.arguments();
    args.pop_front();
    qDebug() << QLibraryInfo::build() << '\n' << args;

    bool create = args.removeAll("-c") > 0;
    QString source = args.value(0);
    QString target = args.value(1);
    if (target.isEmpty()) {
        qDebug() << "arg error!";
        return -1;
    }

    if (!QFile::exists(source)) {
        if (!create) {
            qDebug() << "source non-existent!";
            return -2;
        }
        QFile sF(source);
        if (!sF.open(QIODevice::Text | QIODevice::WriteOnly)) {
            qDebug() << "error writing " << source << sF.errorString();
            return -3;
        }
        sF.write("bla");
    }

    qDebug().noquote() << "Rename" << source << QFileInfo(source).size()
        << QStorageInfo(source).fileSystemType()
        << target << "target exists=" << QFile::exists(target);

    bool r = QFile::rename(source, target);
    qDebug() << "returns " << r << "target exists=" << QFile::exists(target)
             << QFileInfo(target).size();
    return r ? 0 : 1;
}

